

.data?
fres		dq ?

.code


;---------------------------------------------------------------------------------
GetSelText proc FRAME lpBuff :HANDLE
LOCAL	chrg	:CHARRANGE
	
	mov		lpBuff,rcx
	invoke SendMessage,hREdit,EM_EXGETSEL,0,ADDR chrg
	mov		eax,chrg.cpMax
	sub		eax,chrg.cpMin
	.if eax && eax<256
		invoke SendMessage,hREdit,EM_GETSELTEXT,0,lpBuff
	.endif
	ret
GetSelText endp
;---------------------------------------------------------------------------------
Find proc FRAME frType:QWORD
	mov	    frType,rcx
	;Get current selection
	invoke SendMessage,hREdit,EM_EXGETSEL,0,ADDR ft
	;Setup find
	mov		rax,frType
	and		rax,FR_DOWN
	.if rax
		.if fres!=-1		
			add		ft.chrg.cpMin,1
		.endif
		mov		ft.chrg.cpMax,-1
	.else
		mov		ft.chrg.cpMax,0
	.endif
	lea    rax,findbuff
	mov		ft.lpstrText,rax
	;Do the find
	invoke SendMessage,hREdit,EM_FINDTEXTEX,frType,ADDR ft
	mov		fres,rax
	.if rax !=-1
		;Mark the found text
		invoke SendMessage,hREdit,EM_EXSETSEL,0,ADDR ft.chrgText		
		invoke SendMessage,hREdit,EM_SCROLLCARET,0,0
		invoke SendMessage,hREdit, EM_HIDESELECTION,FALSE, 0
	.else
		;Region searched
		invoke GetDlgItem,hFind,IDC_STATUSBAR4901
		.if rax
		      mov rcx,rax
		    invoke SetWindowText,rcx,ADDR szSearched
		.else
    		invoke     MessageBox, NULL, ADDR szSearched, CTEXT("MDIx64"), MB_OK or MB_ICONINFORMATION
    		invoke SetFocus,hREdit
		.endif	

	.endif
	ret

Find endp
;---------------------------------------------------------------------------------
FindDlgProc proc FRAME hWin:HWND,msg:UINT,wParam:WPARAM,lParam:LPARAM
local	hCtl:HWND

		mov		 hWin, rcx   
		mov		 msg, edx  
		mov		 wParam, r8   
		mov		 lParam, r9

	.if edx==WM_INITDIALOG
		mov		hFind,rcx
		.if lParam
			mov		rax,BN_CLICKED
			shl		rax,16
			or		rax,IDC_BTN_REPLACE
			invoke PostMessage,hWin,WM_COMMAND,rax,0
		.endif
		;Put text in edit boxes
		invoke SendDlgItemMessage,hWin,IDC_FINDTEXT,EM_LIMITTEXT,255,0
		invoke SendDlgItemMessage,hWin,IDC_FINDTEXT,WM_SETTEXT,0,ADDR findbuff
		invoke SendDlgItemMessage,hWin,IDC_REPLACETEXT,EM_LIMITTEXT,255,0
		invoke SendDlgItemMessage,hWin,IDC_REPLACETEXT,WM_SETTEXT,0,ADDR replacebuff
		;Set check boxes
		mov		rax,frt
		and		rax,FR_MATCHCASE
		.if rax
			invoke CheckDlgButton,hWin,IDC_CHK_MATCHCASE,BST_CHECKED
		.endif
		mov		rax,frt
		and		rax,FR_WHOLEWORD
		.if rax
			invoke CheckDlgButton,hWin,IDC_CHK_WHOLEWORD,BST_CHECKED
		.endif
		;Set find direction
		mov		rax,frt
		and		rax,FR_DOWN
		.if rax
			mov		rax,IDC_RBN_DOWN
		.else
			mov		rax,IDC_RBN_UP
		.endif
		invoke CheckDlgButton,hWin,eax,BST_CHECKED
		
	.elseif edx==WM_COMMAND
		invoke GetDlgItem,hWin,IDC_STATUSBAR4901
		invoke SetWindowText,rax,0
		mov		rax,wParam
		mov		edx,eax
		shr		edx,16
		and		eax,0FFFFh
		.if edx==BN_CLICKED
			.if eax==IDOK
				;Find the text
				invoke Find,frt
			.elseif eax==IDCANCEL 
				;Close the find dialog
				invoke SendMessage,hWin,WM_CLOSE,NULL,NULL
			.elseif eax==IDC_BTN_REPLACE
				invoke GetDlgItem,hWin,IDC_BTN_REPLACEALL
				mov		hCtl,rax
				invoke IsWindowEnabled,hCtl
				.if !rax
					;Enable Replace all button
					invoke EnableWindow,hCtl,TRUE
					;Set caption to Replace...
					invoke SetWindowText,hWin,ADDR szReplace
					;Show replace
					invoke GetDlgItem,hWin,IDC_REPLACESTATIC
					invoke ShowWindow,rax,SW_SHOWNA
					invoke GetDlgItem,hWin,IDC_REPLACETEXT
					invoke ShowWindow,rax,SW_SHOWNA
				.else	
					.if fres!=-1
						invoke SendMessage,hREdit,EM_EXGETSEL,0,ADDR ft.chrg
						invoke SendMessage,hREdit,EM_REPLACESEL,TRUE,ADDR replacebuff
						invoke lstrlen,ADDR replacebuff
						add		eax,ft.chrg.cpMin
						mov		ft.chrg.cpMax,eax
						invoke SendMessage,hWin,EM_EXSETSEL,0,ADDR ft.chrg
					.endif
					invoke Find,frt
				.endif
			.elseif eax==IDC_BTN_REPLACEALL
				.if fres==-1
					invoke Find,frt
				.endif
				.while fres!=-1
					mov		rax,BN_CLICKED
					shl		rax,16
					or		rax,IDC_BTN_REPLACE
					invoke SendMessage,hWin,WM_COMMAND,rax,0
				.endw
			.elseif eax==IDC_RBN_DOWN
				;Set find direction to down
				or		frt,FR_DOWN
				mov		fres,-1
			.elseif eax==IDC_RBN_UP
				;Set find direction to up
				and		frt,-1 xor FR_DOWN
				mov		fres,-1
			.elseif eax==IDC_CHK_MATCHCASE
				;Set match case mode
				invoke IsDlgButtonChecked,hWin,IDC_CHK_MATCHCASE
				.if eax
					or		frt,FR_MATCHCASE
				.else
					and		frt,-1 xor FR_MATCHCASE
				.endif
				mov		fres,-1
			.elseif eax==IDC_CHK_WHOLEWORD
				;Set whole word mode
				invoke IsDlgButtonChecked,hWin,IDC_CHK_WHOLEWORD
				.if eax
					or		frt,FR_WHOLEWORD
				.else
					and		frt,-1 xor FR_WHOLEWORD
				.endif
				mov		fres,-1
			.endif
		.elseif edx==EN_CHANGE
			;Update text buffers
			.if eax==IDC_FINDTEXT
				invoke SendDlgItemMessage,hWin,eax,WM_GETTEXT,sizeof findbuff,ADDR findbuff
				mov		fres,-1
			.elseif eax==IDC_REPLACETEXT
				invoke SendDlgItemMessage,hWin,eax,WM_GETTEXT,sizeof replacebuff,ADDR replacebuff
				mov		fres,-1
			.endif
		.endif
	.elseif edx==WM_ACTIVATE
		mov		fres,-1
	.elseif edx==WM_CLOSE
		mov		hFind,0
		invoke DestroyWindow,hWin
		invoke SetFocus,hREdit
	.else
		mov rax,FALSE
		ret
	.endif
	mov  rax,TRUE
	ret

FindDlgProc endp
;---------------------------------------------------------------------------------

